%define FSMVER	0.01
%define JSONVER	4.03
%define APSCOBO 0.15
%define apachebasedir /var/GranJefe
%define GJdir	%{_libdir}/GranJefe

%define	perl_archname	%(%{__perl} -MConfig -e 'print $Config{archname}')

Name: GranJefe2
Version: 1.983
Release: 0%{?dist}
%define GJVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
Group: Networking/Daemons

Source0: GJ-%{version}.tar.gz
Source1: GJLibs-%{version}.tar.gz
Source2: GJ-JSON-XS-%{JSONVER}.tar.gz
Source5: gj.logrotate
Source7: File-Stat-Manip-%{FSMVER}.tar.gz
Source9: granjefe.service

License: Distributable
Distribution: MSG Enhanced Linux
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Summary: World Wide Web server enhanced for applications
BuildRequires: gcc
Buildrequires: perl(:VERSION) >= 5.16
Buildrequires: perl-generators perl-devel perl(ExtUtils::Embed)
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires: perl(version)
Requires: perl-libs
Requires: perl(Crypt::DES) >= 2.05
Requires: perl(Net::DNS) perl(URL::Encode::XS)
Requires: perl(Crypt::OpenSSL::Bignum) perl(Crypt::OpenSSL::RSA)
Requires: perl(Crypt::OpenSSL::X509)
Requires: perl(Crypt::CBCeasy) perl(Crypt::PasswdMD5)
Requires: perl(Devel::Symdump) >= 2.01
Requires: perl(YAML::Tiny) >= 1.39
Requires: perl(Archive::Zip) >= 1.20
Requires: perl(Types::Serialiser)
Requires: perl(Net::LDAP) >= 0.34
Requires: perl(Tie::IxHash) >= 1.21
Requires: perl(XML::Simple)
Requires: perl(Cache::Memcached::Fast) >= 0.19
Requires: perl(DBI) perl(Time::HiRes)
Requires: perl(experimental)
Requires: openssl >= 3.2
Requires: httpd >= 2.4
Requires: mod_perl >= 2.0.12
Requires: libapreq2 >= 2.17
Requires: perl-libapreq2 >= 2.10
Requires: mod_ssl >= 2.4
Requires: /usr/sbin/semanage
# For inhouse JSON::XS
#Requires: perl(common::sense)
# For ModMan
Requires: perl(Crypt::OpenSSL::Common)
Requires: perl(File::MimeInfo)
Requires: perl(Digest::SHA1)
Provides: webserver GranJefe
Autoreq: no

%description
GranJefe is a full server side framework based on mod_perl 2.x optimized for WWW applications.
Includes a client side JavaScript framework and a secure VFS for apps distribution

%package sdk
Summary: GranJafe SDK
Requires: GranJefe = %{version}-%{release}
Group: Development/Tools

%description sdk
The GranJefe-sdk package provides tools, libraries and header files for
develop GJ's Framework modules and for extend GranJefe itself

#%package langs
#Summary: GranJefe JS and PHP embedded support
#Requires: GranJefe = %{version}-%{release}
#Requires: php-embedded >= 5.2 perl-PHP-Interpreter >= 1.0.2
#Requires: perl-JSPL >= 1.04
#Group: Development/Tools

#%description langs
#The GranJefe-langs package provides JS server side support and a PHP sapi to program
#GJ modules in the JS and PHP languages, it requires the JSPL module and embeddable
#PHP libraries.

%prep
%setup -T -b 0 -n GJ-%{version}
%setup -T -b 2 -n GJ-JSON-XS-%{JSONVER}
%setup -T -b 7 -n File-Stat-Manip-%{FSMVER}
# %setup -T -b 13 -n Apache-Scoreboard-%{APSCOBO}   TODO

%build

# make GJ
cd ../GJ-%{version}
%{__perl} Makefile.PL \
	PREFIX=%{_prefix} LIB=%{GJdir}/plib \
	OPTIMIZE="$RPM_OPT_FLAGS"
%{__make}

# Make GJ-JSON-XS
cd ../GJ-JSON-XS-%{JSONVER}
%{__perl} Makefile.PL \
	PREFIX=%{_prefix} LIB=%{GJdir}/plib \
	OPTIMIZE="$RPM_OPT_FLAGS"
%{__make}

# Make File-Stat-Manip
cd ../File-Stat-Manip-%{FSMVER}
%{__perl} Makefile.PL \
	PREFIX=%{_prefix} LIB=%{GJdir}/plib \
	OPTIMIZE="$RPM_OPT_FLAGS"
%{__make}

%install
rm -rf $RPM_BUILD_ROOT

# Install GJ Files
cd ../GJ-%{version}
make pure_install PERL_INSTALL_ROOT=${RPM_BUILD_ROOT}
mkdir -p $RPM_BUILD_ROOT%{_docdir}/GranJefe2
cp README* Changes $RPM_BUILD_ROOT%{_docdir}/GranJefe2

# Install File-Stat-Manip
cd ../File-Stat-Manip-%{FSMVER}
make pure_install PERL_INSTALL_ROOT=${RPM_BUILD_ROOT}

# Install GJ-JSON-XS
cd ../GJ-JSON-XS-%{JSONVER}
make pure_install PERL_INSTALL_ROOT=${RPM_BUILD_ROOT}
rm -f ${RPM_BUILD_ROOT}/usr/bin/json_xs #Not needed

# Clean install tree
find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} ';'
find $RPM_BUILD_ROOT -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
#find $RPM_BUILD_ROOT%{apachebasedir} -type d -depth -exec rmdir {} 2>/dev/null ';'

# Make work area
mkdir -p ${RPM_BUILD_ROOT}%{apachebasedir}/plib \
         ${RPM_BUILD_ROOT}%{apachebasedir}/data \
         ${RPM_BUILD_ROOT}%{apachebasedir}/html \
         ${RPM_BUILD_ROOT}%{apachebasedir}/cgi-bin \
		 ${RPM_BUILD_ROOT}%{apachebasedir}/lib \
		 ${RPM_BUILD_ROOT}%{apachebasedir}/state
# include GJLibs
tar -zxC ${RPM_BUILD_ROOT}%{apachebasedir} -f %{SOURCE1}

# Fix perl part
mv $RPM_BUILD_ROOT/usr/share/man/man3 $RPM_BUILD_ROOT%{GJdir}/man/
rm -rf $RPM_BUILD_ROOT/usr/share/man

# Create config directories
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d \
     $RPM_BUILD_ROOT/etc/GranJefe \
     $RPM_BUILD_ROOT/etc/httpd \
     $RPM_BUILD_ROOT/var/log/gj \
     $RPM_BUILD_ROOT%{_rundir}/gj

# Install Extras
install -m644 %{SOURCE5} $RPM_BUILD_ROOT/etc/logrotate.d/gj
mkdir -p $RPM_BUILD_ROOT/usr/lib/systemd/system
install -m755 %{SOURCE9} $RPM_BUILD_ROOT/usr/lib/systemd/system/granjefe.service

# Fix conf link
mv $RPM_BUILD_ROOT%{apachebasedir}/conf/* $RPM_BUILD_ROOT/etc/GranJefe/
rmdir $RPM_BUILD_ROOT%{apachebasedir}/conf
ln -sf /etc/GranJefe $RPM_BUILD_ROOT%{apachebasedir}/conf
ln -srf /var/log/gj $RPM_BUILD_ROOT%{apachebasedir}/logs
ln -sf %{_libdir}/httpd/modules $RPM_BUILD_ROOT%{apachebasedir}/modules
# Connect to httpd
ln -sf %{apachebasedir}/lib $RPM_BUILD_ROOT/etc/httpd/lib

# Connect system ca-bundle
cp $RPM_BUILD_ROOT%{apachebasedir}/lib/resources/MSG_Root.crt $RPM_BUILD_ROOT/etc/GranJefe/ca-bundle.crt
#ln -sf /etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem $RPM_BUILD_ROOT/etc/GranJefe/ssl.crt/ca-bundle.crt

# Clean unused
rm -rf $RPM_BUILD_ROOT%{GJdir}/perl5
rm -rf $RPM_BUILD_ROOT%{GJdir}/plib/0012.gjs
rm -rf $RPM_BUILD_ROOT%{GJdir}/plib/0101.gjs
#rm -rf $RPM_BUILD_ROOT%{GJdir}/plib/%{perl_archname}/auto/Apache/include

%clean
rm -rf $RPM_BUILD_ROOT

%post
semanage fcontext -a -t httpd_config_t "/var/GranJefe(/.*)?"
semanage fcontext -a -t httpd_sys_content_t "/var/GranJefe/html(/.*)?"
semanage fcontext -a -t httpd_var_lib_t "/var/GranJefe/data(/.*)?"
semanage fcontext -a -t httpd_var_lib_t "/var/GranJefe/state(/.*)?"
restorecon -F -R /var/GranJefe
semanage fcontext -a -t httpd_log_t "/var/log/gj(/.*)?"
semanage fcontext -a -t httpd_var_run_t "%{_rundir}/gj(/.*)?"

%preun
#if [ $1 = 0 ]; then
#   /sbin/chkconfig --del gj
#fi

%files
%defattr(-,root,root)
%{GJdir}/man
%{GJdir}/plib/0010.gjs
%{GJdir}/plib/Bootstrap.pm
%{GJdir}/plib/SimpleMime.pm
%{GJdir}/plib/Crypt
%{GJdir}/plib/GJ
%{GJdir}/plib/%{perl_archname}
%doc Changes Changes* README.GranJefe README.GranJefe2
%config /etc/logrotate.d/gj
%config(noreplace) /etc/GranJefe/httpd.conf
%config /etc/GranJefe/ca-bundle.crt
%config /etc/GranJefe/server.crt
%config /etc/GranJefe/server.key
/etc/GranJefe/GJ.conf.sample
%dir /etc/GranJefe/gj.conf.d
%dir %{apachebasedir}
%{apachebasedir}/html
%{apachebasedir}/cgi-bin
%{apachebasedir}/logs
%{apachebasedir}/conf
%{apachebasedir}/conf.d
%{apachebasedir}/conf.modules.d
%{apachebasedir}/modules
%{apachebasedir}/lib
%{apachebasedir}/plib
/etc/httpd/lib
/usr/lib/systemd/system/granjefe.service
%dir /var/log/gj
%dir %{_rundir}/gj
%attr(-,root,apache) %dir %{apachebasedir}/data
%attr(1777,root,apache) %dir %{apachebasedir}/state
%attr(755,root,root) /usr/bin/gjctl
%attr(755,root,root) /usr/bin/gjperl
%attr(755,root,root) /usr/bin/gjservice

%files sdk
%{GJdir}/plib/0004.gjs
%attr(755,root,root) /usr/bin/gjtar
%attr(755,root,root) /usr/bin/ModMan

#%files langs
#%{GJdir}/plib/0012.gjs
#%{GJdir}/plib/0101.gjs

%changelog
* Tue Nov 14 2024 Salvador Ortiz <sog@msg.mx> 1.982-1
- Add direct dependency of libapreq2 and perl-experimental
- Add validation for Persist
- Use _rundir macro
* Sat Nov  9 2024 Salvador Ortiz <sog@msg.mx> 1.981-1
- Fix a typo in Framework
* Sat Nov  9 2024 Salvador Ortiz <sog@msg.mx> 1.981-0
- Add Requires
- Fix remote_ip (undocumented upstream change)
- Fix parsed Args handling
- Add SearchBase for Ldap Authenticate
- Can be build with mod_perl 2.0.12, to allow el9
* Wed Nov  6 2024 Salvador Ortiz <sog@msg.mx> 1.980-3
- More Requires
- A little fix for cookies
* Mon Nov  4 2024 Salvador Ortiz <sog@msg.mx> 1.980-1
- Add needed Requires, p.e. perl-core
- Some previously uncommited fixes.

* Wed Oct 30 2024 Salvador Ortiz <sog@msg.mx> 1.980-0
- First test release for F40
